package org.apithefire.server;

import javax.servlet.Servlet;

import org.apithefire.util.Strings;

public abstract class Context {
	
	protected static final String MATCH_ALL_URL_PATTERN = "/*";
	
	private String name;
	private Servlet servlet;
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		if (name != null) {
			if (name.length() == 0) {
				throw new IllegalArgumentException("Name can not be empty.");
			}
			if (name.contains("/")) {
				throw new IllegalArgumentException("Name can not contains slash.");
			}
		}
		this.name = name;
	}
	
	public String getContextPath() {
		return "/" + Strings.emptyIfNull(name);
	}

	public Servlet getServlet() {
		return servlet;
	}

	public void setServlet(Servlet servlet) {
		this.servlet = servlet;
	}
	
	public void setRequestInfoServlet() {
		this.servlet = new RequestInfoServlet();
	}
	
	protected void validate() {
		if (servlet == null) {
			throw new ServerException("Context servlet is not set.");
		}
	}

	protected abstract void configure(Object serverImpl);

}
